<template>
  <div class="dashboard-investments-page pt-3 pb-5">
    <h2>New Investment</h2>
    <div class="mt-3">
      <!-- <div class="d-flex justify-content-end">
        <button class="btn btn-primary">
          <soan class="me-2"> +</soan> New Investment
        </button>
      </div> -->
      <form @submit.prevent="submitForm">
        <div class="row mt-3">
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 1 - Select Investment type</p>
            <div v-for="(plan, i) in investmentPlans" :key="i" class="mt-3">
              <input
                type="radio"
                name="activeAccount"
                v-model="form.activeAccount"
                :value="trimText(plan.name)"
                :id="trimText(plan.name)"
                class="account-radio d-none"
                @change="fetchDurations"
              />
              <label :for="trimText(plan.name)" class="w-100">
                <div class="investment-type-card">
                  <div class="d-flex">
                    <div>
                      <h5 class="m-0 fw-bold">
                        {{ plan.name }}
                      </h5>
                    </div>
                  </div>
                  <div>
                    <div class="d-flex justify-content-between">
                      <p class="w-75 m-0">
                        {{ plan.description }}
                      </p>
                    </div>

                    <div class="text-end float-end">
                      <p class="fw-bold m-0">
                        Min: {{ plan.minimumAmount | formatPrice }}
                      </p>
                      <p class="fw-bold m-0">ROI: upto {{ plan.roi }}% p.a</p>
                    </div>
                  </div>
                </div>
              </label>
            </div>
          </div>
          <div class="col-sm-12 col-md-4 position-relative">
            <p class="fw-bold">Step 2 - Select amount and duration</p>
            <div class="mt-3">
              <div class="card w-100" ref="investmentContent">
                <div class="form-group">
                  <p class="fw-bold">How much would you like to invest?</p>
                  <label>Amount</label>

                  <currency-input
                    v-model="form.amount"
                    v-validate="'required|decimal'"
                    currency="NGN"
                    class="form-control"
                    type="text"
                    name="Amount"
                  />
                  <div v-show="verrors.has('Amount')" class="invalid-feedback">
                    {{ verrors.first('Amount') }}
                  </div>
                </div>
                <div class="form-group mt-4">
                  <p class="fw-bold">For how long ?</p>
                  <select
                    v-model="form.duration"
                    class="form-select"
                    v-validate="'required'"
                    name="Duration"
                  >
                    <option :value="null">Select Duration</option>
                    <option
                      v-for="(duration, i) in durations"
                      :key="i"
                      :value="duration"
                    >
                      {{ duration }}
                    </option>
                  </select>
                  <div
                    v-show="verrors.has('Duration')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Duration') }}
                  </div>
                </div>
                <div class="form-group my-4">
                  <label class="mb-2 fw-bold">Account to Debit:</label>
                  <select
                    v-model="form.accountFrom"
                    class="form-select"
                    v-validate="'required'"
                    name="Account to Debit"
                  >
                    <option
                      v-for="(account, i) in userAccounts"
                      :key="i"
                      :value="account"
                    >
                      {{ `${account.AccountType} - ${account.AccountNumber}` }}
                    </option>
                  </select>
                  <div
                    v-show="verrors.has('Account to Debit')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Account to Debit') }}
                  </div>
                </div>
                <div class="form-group my-4">
                  <label class="mb-2">Enter your PIN</label>
                  <input
                    type="password"
                    v-model="form.pin"
                    class="form-control"
                    v-validate="'required'"
                    name="Transaction PIN"
                  />
                  <div
                    v-show="verrors.has('Transaction PIN')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Transaction PIN') }}
                  </div>
                </div>
                <div class="mt-4">
                  <p class="fw-bold">ROI</p>
                  <h4 class="fw-bold">{{ currentInvestment.roi }}%</h4>
                </div>
                <!-- <div class="mt-3">
                <p class="fw-bold">Select fund source</p>
                <CurrentAccountBalance />
                <p class="text-primary fw-bold text-center mt-3">
                  Change Fund Source
                </p>
              </div> -->
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 3 - Summary</p>
            <div class="mt-3">
              <div class="card w-100">
                <p class="fw-bold">
                  Here is the summary of what your request looks like
                </p>
                <div class="mt-4 mb-3">
                  <div class="d-flex justify-content-between">
                    <p>Initial Deposit</p>
                    <p class="fw-bold">
                      {{ form.amount | formatPrice }}
                    </p>
                  </div>
                  <div class="d-flex justify-content-between">
                    <p>Estimated amount</p>
                    <p class="fw-bold">
                      {{ form.amount | formatPrice }}
                    </p>
                  </div>

                  <div class="d-flex justify-content-between">
                    <p>Interest Rate</p>
                    <p class="fw-bold">{{ currentInvestment.roi }} %</p>
                  </div>
                  <div class="d-flex justify-content-between">
                    <p>Estsimated interest amount</p>
                    <p class="fw-bold">{{ currentInvestment.roi }} %</p>
                  </div>
                  <!-- <div class="d-flex justify-content-between">
                    <p>Total Interest Earned</p>
                    <p class="fw-bold">0</p>
                  </div> -->
                  <div class="d-flex justify-content-between">
                    <p>Tenure</p>
                    <p class="fw-bold">{{ form.duration || 0 }} months</p>
                  </div>
                  <!-- <div class="d-flex justify-content-between">
                    <p>Total accured</p>
                    <h4 class="fw-bold text-success">
                      {{ 0 }}
                    </h4>
                  </div> -->
                </div>
                <div class="mt-5">
                  <vs-button :loading="form.active" type="submit" class="w-100">
                    Confirm
                  </vs-button>
                </div>
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-6"></div>
        </div>
      </form>
    </div>

    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      class="modal fade"
      id="PaymentSuccessModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Successful!</h3>
              <p class="text-muted my-2 px-3">
                Your investment has been successfully completed and would take
                effect immediately
              </p>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    data-bs-dismiss="modal"
                    type="button"
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    style="font-size: 14px"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'dashboard',
  components: {},
  async asyncData({ $axios }) {
    const investmentPlans = await $axios.$get(
      '/investment/plans?page=1&limit=10'
    )
    const userAccounts = await $axios.$get('/user/accounts')
    // console.log(investmentPlans)
    return {
      investmentPlans: investmentPlans.payload.data,
      userAccounts: userAccounts.payload,
    }
  },
  data: () => ({
    durations: [],
    form: {
      activeAccount: '',
      active: false,
      duration: null,
    },
  }),
  created() {
    this.form.activeAccount = this.trimText(this.investmentPlans[0].name)
    this.form.accountFrom = this.userAccounts[0]
  },
  mounted() {
    this.fetchDurations()
  },
  computed: {
    currentInvestment() {
      const that = this
      return this.investmentPlans.find(function (inv) {
        // console.log(this.trimText(inv.name))
        return that.trimText(inv.name) === that.form.activeAccount
      })
    },
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const data = {
            investmentPlanId: this.currentInvestment.id,
            initialDeposit: this.form.amount,
            duration: this.form.duration,
            accountNumber: this.form.accountFrom.AccountNumber,
            transactionPin: this.form.pin,
          }
          this.form.active = true
          this.$axios
            .post('/investment/invest', data)
            .then(({ data }) => {
              console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('PaymentSuccessModal'),
                {}
              )
              modal.show()
              this.openNotification('top-left', 'success', data.message)
            })
            .catch((error) => {
              // console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    trimText(text) {
      return text.replace(/\s+/g, '-').toLowerCase()
    },
    fetchDurations() {
      const loading = this.$vs.loading({
        target: this.$refs.investmentContent,
        color: 'primary',
        scale: 2,
      })
      this.$axios
        .$get(`/investment/plan/durations/${this.currentInvestment.id}`)
        .then((response) => {
          loading.close()
          this.durations = response.payload.duration
          // this. = response.payload.data
          // console.log(response)
        })
        .catch(() => {
          loading.close()
        })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-investments-page {
  .investment-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  input.form-control,
  .form-select,
  textarea.form-control {
    background-color: #f4f2ec;
    border-radius: 5px;
    border: none;
  }

  input.account-radio:checked + label {
    .investment-type-card {
      // background-color: red;
      background-position: 98% 4%, right top;
      background-image: url(~@/assets/images/tick.png),
        url(~@/assets/icons/image-26.svg);
    }
  }
  .investment-type-card,
  .coreflex-card {
    min-height: 200px;
    width: 100%;
    background-color: #fff;
    background-image: url(~@/assets/icons/image-26.svg);
    border-radius: 20px;
    padding: 16px 20px;
    background-repeat: no-repeat;
    background-position: right top;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    margin-bottom: 20px;
  }
}
</style>
